function [particle] = AlgorithmAnalytic(part,A1,A2,AL,Duration,...
    FB,FD,FP,MinBulk,MinDeck,MinPax,RndDist,AvgDist,SpreadDep)

DayrateCost=0; FuelCost=0; Trips=0; PSVs=0; AvgCons=0; AvgSpeed=0;
Consumption=0; TransSpeed=0; FlightHours=0; FlightCost=0;

for j=1:AL
    DayrateCost=DayrateCost+part(j)*A2(j,1)*Duration/24;
    Consumption=Consumption+part(j)*A2(j,3); %Bare seiling
    PSVs=PSVs+part(j);
    TransSpeed=TransSpeed+part(j)*A2(j,7);
end
AvgCons=Consumption/PSVs;
AvgSpeed=TransSpeed/PSVs;
Trips=min(Duration/SpreadDep,Duration*AvgSpeed*PSVs/RndDist);
FuelCost=Trips*AvgCons/24*RndDist/AvgSpeed*A1(2);
FlightHours=min(MinPax*100/7/A2(9,14)*(2*AvgDist)/A2(9,7)*1.3,2*part(9)*((2*AvgDist)/A2(9,7)+2)*Duration/24); %part(9) og A2(9,7) og A2(9,14) br vre dynamiske. F.eks. etter speed.
FlightCost=A1(21)*FlightHours;

Bulk=0;Deck=0;Pax=0;ShipPax=0;HoursinWeek=168;
for j=1:AL
    if A2(j,7)<80 %Skiller bter og helikoptre
        Bulk=Bulk+part(j)*A2(j,8);
        Deck=Deck+part(j)*A2(j,9);
        ShipPax=ShipPax+part(j)*A2(j,14);
    elseif A2(j,7)>80
        Pax=Pax+A2(j,14)*FlightHours/((2*AvgDist)/A2(j,7));
    end
    if part(j)>0 && part(j)*A2(j,8)==0 && part(j)*A2(j,9)==0 && part(j)*A2(j,14)==0 %Unng "dummy-skip" som PSVstandby
        FuelCost=inf;
    end
end

Bulk=Bulk/PSVs*Trips/(100/7);
Deck=Deck/PSVs*Trips/(100/7);
ShipPax=ShipPax/PSVs*Trips;
Pax=(Pax+ShipPax)/(100/7);

Bulk=prod(FB)*Bulk;
Deck=prod(FD)*Deck;
Pax=prod(FP)*Pax;
part(AL+2)=Bulk;
part(AL+3)=Deck;
part(AL+4)=Pax;
%HVA MINBULK, MINDECK OG MINPAX BR VRE ER EGENTLIG GANSKE VANSKELIG 
%FINNE UT.
if Bulk>MinBulk && Deck>MinDeck && Pax>MinPax
    part(AL+1)=DayrateCost+FuelCost+FlightCost;
else
    part(AL+1)=inf;%10*(DayrateCost+FuelCost)+10^10;
end
particle=part;
end