function [BestGA] = AlgorithmGA3(Generations,AntPar,AL,A1,A2,part,...
    Duration,FB,FD,FP,MinBulk,MinDeck,MinPax,ARS,RndDist,AvgDist,SpreadDep) 

for j=1:AL
    size(j)=max(part(:,j))-min(part(:,j));
    Range(j,:)=[min(part(:,j)) min(part(:,j)+size(j))];
end

part=sortrows(part,AL+1);
BestGA=part;

contD=ones(AL,1);
for i=1:AL
    if Range(i,1)==Range(i,2)
        cont(i)=0;
    end
end

for k=1:Generations
    %Mutere %velge random dim blant de som ikke er fixa og +1 eller -1.
    for i=1:AntPar
        %Velg en dimensjon
        d=randi(AL);
        while contD(d)==0
            d=randi(AL);
        end
        %+1 eller -1 for den variablen.
        if part(i,d)==Range(d,1)
            part(i,d)=part(i,d)+1;
        elseif part(i,d)==Range(d,1)
            part(i,d)=part(i,d)-1;
        else
            part(i,d)=part(i,d)+(1-2*round(rand));
        end
        %Evaluate the solution.
        part(i,:)=AlgorithmAnalytic(part(i,:),A1,A2,AL,Duration,...
                FB,FD,FP,MinBulk,MinDeck,MinPax,RndDist,AvgDist,SpreadDep);
        if part(i,AL+1)<BestGA(end,AL+1)
            lik=0;
            for m=1:AntPar
                if sum(part(i,1:AL)==BestGA(m,1:AL))==AL
                    lik=1;
                    break;
                end
            end
            if lik==0
                BestGA(end,:)=part(i,:);
                BestGA=sortrows(BestGA,AL+1);
            end
        end
    end
    %Selection
    part=sortrows(part,AL+1);
    part=part(1:round(AntPar/4),:);
    %Reprodusere
    for i=(round(AntPar/4)+1):AntPar
        %M se p denne p nytt
        part(i,1:ceil(AL/2))=part(ceil(round(AntPar/4)*rand),1:ceil(AL/2));
        part(i,ceil(AL/2)+1:AL)=part(ceil(round(AntPar/4)*rand),ceil(AL/2)+1:AL);
        part(i,:)=AlgorithmAnalytic(part(i,:),A1,A2,AL,Duration,...
        FB,FD,FP,MinBulk,MinDeck,MinPax,RndDist,AvgDist,SpreadDep);
        if part(i,AL+1)<BestGA(end,AL+1)
            %hvis den ikke ligger der fra fr
            lik=0;
            for m=1:AntPar
                if (part(i,1:AL)==BestGA(m,1:AL))>0
                    lik=1;
                    break;
                end
            end
            if lik==0
                BestGA(end,:)=part(i,:);
                BestGA=sortrows(BestGA,AL+1);
            end
        end       
    end
    part=sortrows(part,AL+1);
end
end

