function [BestNP] = AlgorithmNP(Duration,AL,ARS,A1,A2,R,FB,FD,FP,MinBulk,...
    MinDeck,MinPax,RndDist,AvgDist,SpreadDep)

for r=1:R
    BestNP(r,:)=[zeros(1,AL) inf zeros(1,3)];
    cont=ones(AL,1);
    for i=1:AL
        if ARS(i,2)==ARS(i,1)
            cont(i)=0;
        end
    end
    contS=1;
    RS=ARS;
    while contS==1
        d=ceil(length(ARS(:,1))*rand);
        if cont(d)==1
            Limits(d,:)=[RS(d,1),floor((RS(d,2)-RS(d,1))/2)+RS(d,1),...
                floor((RS(d,2)-RS(d,1))/2)+RS(d,1)+1,RS(d,2)];
            DP(d,1)=round((Limits(d,2)-Limits(d,1))*rand())+Limits(d,1);
            DP(d,2)=round((Limits(d,4)-Limits(d,3))*rand())+Limits(d,3);
            for k=1:AL
                part(k)=round((RS(k,2)-RS(k,1))*rand())+RS(k,1);
            end
            if RS(d,1)==ARS(d,1) && RS(d,2)==ARS(d,2)
                A=2;
            else
                A=4;
                if RS(d,2)<ARS(d,2)
                    DP(d,3)=ceil((ARS(d,2)-RS(d,2))*rand)+RS(d,2);
                    DP(d,4)=ceil((ARS(d,2)-RS(d,2))*rand)+RS(d,2);
                    if RS(d,1)>ARS(d,1)
                        a=ARS(d,2)-RS(d,2);
                        b=RS(d,1)-ARS(d,1);
                        tilf=rand;
                        if tilf<a/(a+b)
                            DP(d,3)=ceil((ARS(d,2)-RS(d,2))*rand)+RS(d,2);
                            DP(d,4)=ceil((ARS(d,2)-RS(d,2))*rand)+RS(d,2);
                        else
                            DP(d,3)=round((RS(d,1)-ARS(d,1)-1)*rand)+ARS(d,1);
                            DP(d,4)=round((RS(d,1)-ARS(d,1)-1)*rand)+ARS(d,1);
                        end
                    end
                elseif RS(d,1)>ARS(d,1)
                    DP(d,3)=round((RS(d,1)-ARS(d,1)-1)*rand)+ARS(d,1);
                    DP(d,4)=round((RS(d,1)-ARS(d,1)-1)*rand)+ARS(d,1);
                end
            end
            for a=1:A
                part(d)=DP(d,a);
                part=AlgorithmAnalytic(part,A1,A2,AL,Duration,...
                    FB,FD,FP,MinBulk,MinDeck,MinPax,RndDist,AvgDist,SpreadDep);
                SolVal(a)=part(AL+1);
                if part(AL+1)<BestNP(r,AL+1)
                    BestNP(r,:)=part;
                end              
            end
            if A==2
                if SolVal(1)<=SolVal(2)
                    RS(d,1)=Limits(d,1);
                    RS(d,2)=Limits(d,2);
                elseif SolVal(2)<SolVal(1)
                    RS(d,1)=Limits(d,3);
                    RS(d,2)=Limits(d,4);
               end
            elseif A==4
                if SolVal(1)<=SolVal(2) && SolVal(1)<=SolVal(3) && SolVal(1)<=SolVal(4)
                    RS(d,1)=Limits(d,1);
                    RS(d,2)=Limits(d,2);
                elseif SolVal(2)<SolVal(1) && SolVal(2)<SolVal(3) && SolVal(2)<SolVal(4)
                    RS(d,1)=Limits(d,3);
                    RS(d,2)=Limits(d,4);
                elseif SolVal(3)<SolVal(1) && SolVal(3)<SolVal(2) && SolVal(3)<SolVal(4)
                    RS(d,1)=ARS(d,1);
                    RS(d,2)=ARS(d,2);
                elseif SolVal(4)<SolVal(1) && SolVal(4)<SolVal(2) && SolVal(4)<SolVal(3)
                    RS(d,1)=ARS(d,1);
                    RS(d,2)=ARS(d,2);
                end
            end
            RS3=RS;
            if RS(d,2)-RS(d,1)<ARS(d,3)
                cont(d)=0;
            end
            if sum(cont)==0
                contS=0;
            end
        end
    end
end
BestNP=sortrows(BestNP,AL+1);
end

