function [BestNPUnique] = AlgorithmUnique(BestNP,AL,NoFromNP)
j=0;
sol=zeros(1,AL+4);
for i=1:length(BestNP(:,1)) %For every solution in the input matrix.
    lik=0;
    for k=1:length(sol(:,1)) %For every solution previously stored from the input matrix.
        if sum(BestNP(i,1:AL)==sol(k,1:AL))==AL %If this solution equals one that is previously checked (that is, has a smaller index value).
            lik=1; 
            break;
        end
    end
    if lik==0 %If this solution has not been seen before in this input matrix.
        j=j+1;
        sol(j,:)=BestNP(i,:); %Add to the list of seen solutions. 
    end
    if j==NoFromNP
        break;
    end
end
BestNPUnique=sol;
end

